Disk ARchive: libdar::compressor Class Reference

| Disk ARchive 2.8.1 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::compressor Class Reference
Private

compression class for gzip and bzip2 algorithms More...

`#include <compressor.hpp>`

## Public Member Functions
| compressor (compression x_algo, generic_file &compressed_side, U_I compression_level=9)
| compressor (const compressor &ref)=delete
| compressor (compressor &&ref) noexcept=delete
compressor & | operator= (const compressor &ref)=delete
compressor & | operator= (compressor &&ref) noexcept=delete
virtual compression | get_algo () const override
virtual void | suspend_compression () override
virtual void | resume_compression () override
virtual bool | is_compression_suspended () const override
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions

## Private Member Functions
void | flush_write ()
| drop all pending write and reset compression engine

## Private Attributes
xfer * | compr
| datastructure for bzip2, gzip and zx compression (not use with compression::none
bool | read_mode
| read-only mode or write-only mode, read-write is write-only mode
generic_file * | compressed
| where to read from/write to compressed data
compression | algo
| compression algorithm used
bool | suspended
| whether compression is temporary suspended

## Detailed Description

compression class for gzip and bzip2 algorithms

Definition at line 44 of file compressor.hpp.

## Constructor & Destructor Documentation

## ◆ compressor() [1/2]

libdar::compressor::compressor | ( | compression | x_algo,
|  | generic_file & | compressed_side,
|  | U_I | compression_level = 9 )

Parameters

  x_algo | only gzip, bzip2, xz and none are supported by this class
  compressed_side | where to read from/write to compressed data
  compression_level | compression level 1..9

Referenced by compressor().

## ◆ compressor() [2/2]

libdar::compressor::compressor | ( | const compressor & | ref | ) |
| delete

Note
  compressed_side is not owned by the object and will remains (and must survive) upt to this compressor objet destruction

References compressor(), and suspended.

## Member Function Documentation

## ◆ get_position()

virtual infinint libdar::compressor::get_position | ( |  | ) | const
| inlineoverridevirtual

get the current read/write position

Implements libdar::generic_file.

Definition at line 76 of file compressor.hpp.

References compr, and compressed.

## ◆ inherited_flush_read()

virtual void libdar::compressor::inherited_flush_read | ( |  | ) |
| overrideprotectedvirtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Referenced by skip(), skip_relative(), and skip_to_eof().

## ◆ inherited_read()

virtual U_I libdar::compressor::inherited_read | ( | char * | a,
|  | U_I | size )
| overrideprotectedvirtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::compressor::inherited_read_ahead | ( | const infinint & | amount | ) |
| inlineoverrideprotectedvirtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 79 of file compressor.hpp.

References compressed.

## ◆ inherited_sync_write()

virtual void libdar::compressor::inherited_sync_write | ( |  | ) |
| overrideprotectedvirtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Referenced by skip(), skip_relative(), and skip_to_eof().

## ◆ inherited_terminate()

virtual void libdar::compressor::inherited_terminate | ( |  | ) |
| overrideprotectedvirtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

## ◆ inherited_truncate()

virtual void libdar::compressor::inherited_truncate | ( | const infinint & | pos | ) |
| overrideprotectedvirtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

## ◆ inherited_write()

virtual void libdar::compressor::inherited_write | ( | const char * | a,
|  | U_I | size )
| overrideprotectedvirtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ is_compression_suspended()

virtual bool libdar::compressor::is_compression_suspended | ( |  | ) | const
| inlineoverridevirtual

Definition at line 66 of file compressor.hpp.

## ◆ skip()

virtual bool libdar::compressor::skip | ( | const infinint & | pos | ) |
| inlineoverridevirtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

Definition at line 72 of file compressor.hpp.

References compressed, inherited_flush_read(), and inherited_sync_write().

## ◆ skip_relative()

virtual bool libdar::compressor::skip_relative | ( | S_I | x | ) |
| inlineoverridevirtual

skip relatively to the current position

Implements libdar::generic_file.

Definition at line 74 of file compressor.hpp.

References compressed, inherited_flush_read(), and inherited_sync_write().

## ◆ skip_to_eof()

virtual bool libdar::compressor::skip_to_eof | ( |  | ) |
| inlineoverridevirtual

skip to the end of file

Implements libdar::generic_file.

Definition at line 73 of file compressor.hpp.

References compressed, inherited_flush_read(), and inherited_sync_write().

## ◆ skippable()

virtual bool libdar::compressor::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| inlineoverridevirtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 71 of file compressor.hpp.

References compressed.

## ◆ truncatable()

virtual bool libdar::compressor::truncatable | ( | const infinint & | pos | ) | const
| inlineoverridevirtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

Definition at line 75 of file compressor.hpp.

References compressed.

## Member Data Documentation

## ◆ algo

compression libdar::compressor::algo
| private

compression algorithm used

Definition at line 101 of file compressor.hpp.

## ◆ compr

xfer* libdar::compressor::compr
| private

datastructure for bzip2, gzip and zx compression (not use with compression::none

Definition at line 98 of file compressor.hpp.

Referenced by get_position().

## ◆ compressed

generic_file* libdar::compressor::compressed
| private

where to read from/write to compressed data

Definition at line 100 of file compressor.hpp.

Referenced by get_position(), inherited_read_ahead(), skip(), skip_relative(), skip_to_eof(), skippable(), and truncatable().

## ◆ read_mode

bool libdar::compressor::read_mode
| private

read-only mode or write-only mode, read-write is write-only mode

Definition at line 99 of file compressor.hpp.

## ◆ suspended

bool libdar::compressor::suspended
| private

whether compression is temporary suspended

Definition at line 102 of file compressor.hpp.

Referenced by compressor().

The documentation for this class was generated from the following file:

- compressor.hpp